; ArrowLISP Example Program
; Copyright (C) 1998-2006 Nils M Holm. All rights reserved.
; See the file LICENSE of the ArrowLISP distribution
; for conditions of use.

; Convert LET to LAMBDA.
; (unlet '(let ((x '#5)) (- x))) => '((lambda (x) (- x)) '#5)

(define (unlet x)
  (letrec

  ; Create list of symbols bound in LET
  ((symlist (lambda (x r)
    (cond ((null x) (reverse r))
      (t (symlist (cdr x)
                  (cons (caar x)
                        r))))))

  ; Create list of (unleted) values bound in LET
  (vallist (lambda (x r)
    (cond ((null x) (reverse r))
      (t (vallist (cdr x)
                  (cons (unlet (cadar x))
                        r))))))

  ; Extract (unleted) term of label
  (term (lambda (x) (unlet (caddr x))))

  ; Create lambda expression
  (make-lambda (lambda (x)
    (append (list (list 'lambda
                        (symlist (cadr x) ())
                        (term x)))
            (vallist (cadr x) ())))))

  ; Traverse expression tree, replacing labels with lambda
  (cond ((atom x) x)
    ((eq (car x) 'quote) x)
    ((eq (car x) 'let) (make-lambda x))
    (t (cons (unlet (car x))
             (unlet (cdr x)))))))
